"""
Django settings for madbot_api project.

Generated by 'django-admin startproject' using Django 4.1.4.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

import os
import sys
from pathlib import Path

import environ
from django.core.management.utils import get_random_secret_key

# ======================================================================================
# Setup django environ
# ======================================================================================

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

env = environ.Env(
    # set casting, default value
    DEBUG=(bool, False),
)

env_paths = [
    environ.Path(Path.joinpath(BASE_DIR, ".env")),
    environ.Path("/etc/madbot/madbot.env"),
]

if env.str("MADBOT_ENV_PATH", default="") != "":
    env_paths.insert(0, environ.Path(env.str("MADBOT_ENV_PATH")))

# Read all environment files
for e in env_paths:
    try:
        e.file("")
        env.read_env(e())
    except FileNotFoundError:
        pass

# ======================================================================================
# Dynamic settings
# ======================================================================================

# Django basics
ALLOWED_HOSTS = env.list("ALLOWED_HOSTS", default=["localhost"])
SECRET_KEY = env("SECRET_KEY", default=get_random_secret_key())
DEBUG = env("DEBUG", default=False)
CSRF_TRUSTED_ORIGINS = env.list("CSRF_TRUSTED_ORIGINS", default=[])
USE_X_FORWARDED_HOST = env.bool("USE_X_FORWARDED_HOST", default=False)
SECURE_PROXY_SSL_HEADER = env.tuple("SECURE_PROXY_SSL_HEADER", default=())

# SQL backend
DATABASES = {
    "default": env.db(default=f"sqlite:///{BASE_DIR}/db.sqlite3"),
}

# Redis backend
REDIS_HOST = env("REDIS_HOST", default="localhost")
REDIS_PORT = env("REDIS_PORT", default=6379)

# Vault backend
MADBOT_VAULT_URL = env("MADBOT_VAULT_URL", default="")
MADBOT_VAULT_MOUNT_POINT = env("MADBOT_VAULT_MOUNT_POINT", default="")
MADBOT_VAULT_ROLEID = env("MADBOT_VAULT_ROLEID", default="")
MADBOT_VAULT_SECRETID = env("MADBOT_VAULT_SECRETID", default="")

# Email backend
EMAIL_HOST = env("EMAIL_HOST", default=None)
EMAIL_PORT = env("EMAIL_PORT", default=None)
DEFAULT_FROM_EMAIL = env("DEFAULT_FROM_EMAIL", default="from@example.com")
DEFAULT_SUPPORT_EMAIL = env("DEFAULT_SUPPORT_EMAIL", default="support@example.com")

# Static files
STATIC_ROOT = env("STATIC_ROOT", default=".static")

# OAuth
MADBOT_OIDC_RSA_PRIVATE_KEY = env.str(
    "MADBOT_OIDC_RSA_PRIVATE_KEY",
    multiline=True,
    default="",
)

# AllAuth

ACCOUNT_EMAIL_VERIFICATION = env("ACCOUNT_EMAIL_VERIFICATION", default="none")
if "LOGIN_REDIRECT_URL" in env:
    LOGIN_REDIRECT_URL = env("LOGIN_REDIRECT_URL")

# ORCID
ENABLE_ORCID_AUTH = env.bool("ENABLE_ORCID_AUTH", default=False)
if ENABLE_ORCID_AUTH:
    ORCID_PROVIDER = {
        "APP": {
            "client_id": env("ORCID_CLIENT_ID"),
            "secret": env("ORCID_CLIENT_SECRET"),
        },
        "BASE_DOMAIN": env("ORCID_BASE_DOMAIN"),
        "MEMBER_API": True,
    }

# Flower
FLOWER_ADMIN_USER = env("FLOWER_ADMIN_USER", default="")
FLOWER_ADMIN_PASSWORD = env("FLOWER_ADMIN_PASSWORD", default="")

# Madbot connectors
default_connectors = []
MADBOT_INSTALLED_CONNECTORS = env.list(
    "MADBOT_INSTALLED_CONNECTORS",
    default=default_connectors,
)

# Enable silky profiler
SILKY_PYTHON_PROFILER = env.bool("SILKY_PYTHON_PROFILER", default=False)


# Support
MADBOT_SUPPORT_EMAIL = env("MADBOT_SUPPORT_EMAIL", default="")
MADBOT_TERMS_URL = env("MADBOT_TERMS_URL", default="")
MADBOT_PRIVACY_URL = env("MADBOT_PRIVACY_URL", default="")

# ======================================================================================
# Static settings
# ======================================================================================

TESTING = len(sys.argv) > 1 and sys.argv[1] == "test"


# Application definition
INSTALLED_APPS = [
    "daphne",
    "corsheaders",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django_celery_results",
    "madbot_api.core",
    "rest_framework",
    "django_filters",
    "drf_spectacular",
    "oauth2_provider",
    "simple_history",
    "notifications",
    "allauth",
    "allauth.account",
    "allauth.socialaccount",
    "allauth.mfa",
    "invitations",
    "health_check",
    "health_check.db",
    "health_check.cache",
    "health_check.storage",
    "health_check.contrib.migrations",
    "madbot_api.core.health_check.vault",
    "health_check.contrib.redis",
    "health_check.contrib.celery",
    "health_check.contrib.celery_ping",
    "django_celery_beat",
]

if TESTING:
    INSTALLED_APPS.append("madbot_api.core.tests.fake_connector")

INSTALLED_APPS.extend(MADBOT_INSTALLED_CONNECTORS)

AUTH_USER_MODEL = "core.MadbotUser"

MIDDLEWARE = [
    "corsheaders.middleware.CorsMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "oauth2_provider.middleware.OAuth2TokenMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "simple_history.middleware.HistoryRequestMiddleware",
    "allauth.account.middleware.AccountMiddleware",
]

LOGIN_URL = "/accounts/login/"

ROOT_URLCONF = "madbot_api.urls"
BASE_DIR = Path(__file__).resolve().parent.parent

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [BASE_DIR / "templates"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "django_settings_export.settings_export",
            ],
        },
    },
]

SETTINGS_EXPORT = ["MADBOT_SUPPORT_EMAIL"]

WSGI_APPLICATION = "madbot_api.wsgi.application"

# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/
STATIC_URL = "/static/"
STATICFILES_FINDERS = [
    "django.contrib.staticfiles.finders.AppDirectoriesFinder",
]

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

REST_FRAMEWORK = {
    "EXCEPTION_HANDLER": "madbot_api.core.views.utils.exception_handler.custom_exception_handler",
    "DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination",
    "PAGE_SIZE": 10,
    "DEFAULT_SCHEMA_CLASS": "drf_spectacular.openapi.AutoSchema",
    "DEFAULT_FILTER_BACKENDS": (
        "django_filters.rest_framework.DjangoFilterBackend",
        "rest_framework.filters.SearchFilter",
        "rest_framework.filters.OrderingFilter",
    ),
}

OAUTH2_PROVIDER = {
    "SCOPES": {
        "read": "View your ISA objects and datalinks",
        "write": "Add, edit or delete ISA objects and datalinks",
        "openid": "View your OpenID information",
        "email": "View your email address",
        "profile": "View your user profile",
    },
    "OAUTH2_VALIDATOR_CLASS": "madbot_api.core.views.utils.oauth_validators.CustomOAuth2Validator",
    "OIDC_RSA_PRIVATE_KEY": MADBOT_OIDC_RSA_PRIVATE_KEY,
    "OIDC_ENABLED": True,
    "PKCE_REQUIRED": False,
}

CORS_ALLOW_ALL_ORIGINS = True

CORS_ALLOW_HEADERS = [
    "accept",
    "authorization",
    "content-type",
    "origin",
    "user-agent",
    "x-csrftoken",
    "x-requested-with",
    "x-workspace",
]

AUTHENTICATION_BACKENDS = [
    "oauth2_provider.backends.OAuth2Backend",
    "django.contrib.auth.backends.ModelBackend",
    "allauth.account.auth_backends.AuthenticationBackend",
]

# Spectacular settings
SPECTACULAR_SETTINGS = {
    "TITLE": "Madbot API",
    "DESCRIPTION": "API of Madbot, the Metadata And Data Brokering Online Tool",
    "VERSION": "1.0.0",
    "SERVE_INCLUDE_SCHEMA": False,
    "EXTRA_HEADER_PARAMETERS": {
        "X-Workspace": {
            "name": "X-Workspace",
            "description": "Workspace ID",
            "required": False,
            "schema": {"type": "string", "default": "Default Workspace ID"},
        },
    },
    "APPEND_COMPONENTS": {
        "securitySchemes": {
            "ApiKeyAuth": {
                "type": "apiKey",
                "in": "header",
                "name": "Authorization",
            },
        },
    },
    "SECURITY": [
        {
            "ApiKeyAuth": [],
        },
    ],
}


ASGI_APPLICATION = "madbot_api.asgi.application"

CHANNEL_LAYERS = {
    "default": {
        "BACKEND": "channels_redis.core.RedisChannelLayer",
        "CONFIG": {
            "hosts": [(REDIS_HOST, REDIS_PORT)],
        },
    },
}

# ======================================================================================
# Silk configuration
# ======================================================================================

# Load silk app and middleware if silk profiler is enable
if SILKY_PYTHON_PROFILER:
    INSTALLED_APPS.append("silk")
    MIDDLEWARE.insert(-1, "silk.middleware.SilkyMiddleware")

# ======================================================================================
# Logging configuration
# ======================================================================================

LOG_PATH = os.path.join(BASE_DIR, "log/")
LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "formatters": {
        "simple": {
            "format": "{levelname} {asctime} {message}",
            "style": "{",
        },
        "verbose": {
            "format": "{levelname} {asctime} {message}",
            "style": "{",
        },
        "error": {
            "format": "{asctime} {id} {message}\n{traceback}",
            "style": "{",
        },
    },
    "filters": {
        "require_debug_true": {
            "()": "django.utils.log.RequireDebugTrue",
        },
    },
    "handlers": {
        "console": {
            "level": "INFO",
            "filters": ["require_debug_true"],
            "class": "logging.StreamHandler",
            "formatter": "simple",
        },
        "debug": {
            "level": "DEBUG",
            "filters": ["require_debug_true"],
            "class": "logging.StreamHandler",
            "formatter": "simple",
        },
        "log": {
            "level": "WARNING",
            "class": "madbot_api.core.views.utils.logger.MakeFileHandler",
            "filename": LOG_PATH + "django.log",
            "when": "midnight",
            "backupCount": 10,
            "formatter": "verbose",
        },
        "error": {
            "level": "ERROR",
            "class": "madbot_api.core.views.utils.logger.MakeFileHandler",
            "filename": LOG_PATH + "error.log",
            "when": "midnight",
            "backupCount": 10,
            "formatter": "error",
        },
        "celery": {
            "level": "DEBUG",
            "class": "madbot_api.core.views.utils.logger.MakeFileHandler",
            "filename": LOG_PATH + "celery.log",
            "when": "midnight",
            "backupCount": 10,
            "formatter": "verbose",
        },
    },
    "loggers": {
        "django": {
            "handlers": ["console"],
            "level": "DEBUG",
            "propagate": True,
        },
        "madbot": {
            "handlers": ["log", "error"],
            "level": "DEBUG",
            "propagate": True,
        },
        "madbot_api.core": {
            "handlers": ["debug"],
            "level": "DEBUG",
            "propagate": True,
        },
        "madbot_api.core.tasks": {
            "handlers": ["celery"],
            "level": "INFO",
            "propagate": True,
        },
    },
}

# ======================================================================================
# Email configuration
# ======================================================================================

EMAIL_BACKEND = os.environ.get(
    "EMAIL_BACKEND",
    "django.core.mail.backends.filebased.EmailBackend",
)
EMAIL_FILE_PATH = str(BASE_DIR.joinpath("sent_emails"))

# ======================================================================================
# Healthcheck configuration
# ======================================================================================
REDIS_URL = f"redis://{REDIS_HOST}:{REDIS_PORT}"

# ======================================================================================
# Allauth & invitations
# ======================================================================================

# ======================================================================================
# Allauth configuration
# ======================================================================================

# ACCOUNT_ADAPTER = "invitations.models.InvitationsAdapter"
ACCOUNT_ADAPTER = "madbot_api.core.views.utils.accounts.adapters.CustomAccountAdapter"
INVITATIONS_SIGNUP_REDIRECT = "account_signup"
ACCOUNT_SESSION_REMEMBER = False
ACCOUNT_LOGIN_METHODS = {"email", "username"}
SOCIALACCOUNT_QUERY_EMAIL = True
ACCOUNT_EMAIL_REQUIRED = True
MFA_ADAPTER = "allauth.mfa.adapter.DefaultMFAAdapter"
ACCOUNT_SIGNUP_REDIRECT_URL = "awaiting_approval"
ACCOUNT_FORMS = {
    "signup": "madbot_api.core.views.utils.accounts.forms.CustomSignupForm"
}


# ======================================================================================
# Social providers
# ======================================================================================

SOCIALACCOUNT_ADAPTER = (
    "madbot_api.core.views.utils.accounts.adapters.CustomSocialAccountAdapter"
)
SOCIALACCOUNT_SIGNUP_REDIRECT_URL = "awaiting_approval"
SOCIALACCOUNT_AUTO_SIGNUP = False

SOCIALACCOUNT_FORMS = {
    "signup": "madbot_api.core.views.utils.accounts.forms.CustomSocialSignupForm"
}

SOCIALACCOUNT_PROVIDERS = {}

if ENABLE_ORCID_AUTH:
    INSTALLED_APPS.append("allauth.socialaccount.providers.orcid")
    SOCIALACCOUNT_PROVIDERS["orcid"] = ORCID_PROVIDER

ENABLE_GITLAB_AUTH = env.bool("ENABLE_GITLAB_AUTH", default=False)
if ENABLE_GITLAB_AUTH:
    INSTALLED_APPS.append("allauth.socialaccount.providers.gitlab")
    SOCIALACCOUNT_PROVIDERS["gitlab"] = {
        "APP": {
            "client_id": env(
                "GITLAB_CLIENT_ID", ""
            ),  # Fetch client ID from environment
            "secret": env("GITLAB_CLIENT_SECRET", ""),  # Fetch secret from environment
        }
    }

# ======================================================================================
# Celery configuration
# ======================================================================================

CELERY_BROKER_URL = REDIS_URL
CELERY_RESULT_BACKEND = "django-db"

CELERY_ACCEPT_CONTENT = ["json"]
CELERY_TASK_SERIALIZER = "json"
CELERY_RESULT_SERIALIZER = "json"
CELERY_TIMEZONE = "UTC"
CELERY_TASK_TRACK_STARTED = True
CELERY_TASK_TIME_LIMIT = 3600
FILE_UPLOAD_MAX_MEMORY_SIZE = 26214400

# ======================================================================================
# Flower configuration
# ======================================================================================

# Flower settings
CELERY_FLOWER_OPTIONS = {"basic_auth": f"{FLOWER_ADMIN_USER}:{FLOWER_ADMIN_PASSWORD}"}
# FLOWER_URL_PREFIX = "flower"
# FLOWER_HOST = env("FLOWER_HOST", default="localhost")
# FLOWER_PORT = env("FLOWER_PORT", default="5555")

# ===========================
# Tasks
# ===========================

# Frequency of connection verification in seconds (once a day)
# connections will only be verified if their credentials have not been modified in the last 24 hours
VERIFY_CONNECTIONS_FREQUENCY = 86400  # 24 hours
